	title		"Kids' Keyboard"
; Working 2013 03 03
; -----  Pic ID = 004  -----
; ----- Hardware Notes -----
; A0 pin 17 (o) LCD-D0
; A1 pin 18 (o) LCD-D1
; A2 pin  1 (o) LCD-D2
; A3 pin  2 (o) LCD-D3
; A4 pin  3 (o) -
; A5 pin  4 (i) -
; A6 pin 15 (o) LCD-RS
; A7 pin 16 (o) LCD-E
; B0 pin  6 (i) -
; B1 pin  7 (i) -
; B2 pin  8 (o) -
; B3 pin  9 (o) Data out
; B4 pin 10 (o) Monitor out
; B5 pin 11 (i) -
; B6 pin 12 (i) -
; B7 pin 13 (i) Remote IR in

	LIST 		P=16F88
	errorlevel 	0,			-302
	#INCLUDE 	"p16F88.inc"
	__CONFIG	_CONFIG1, _INTRC_IO & _WDT_OFF & _LVP_OFF & _MCLR_OFF

	CBLOCK		0x20
	bit_in
	buffer_in
	flags		; 0:Test 1:High detected 6:LCD Data Mode
	delH
	delL
	LCD_Byte
	position
	Ruwido_Char
	temp
	ENDC

	org 		0
;	call		LCD_WriteChar
	goto		Init
	org			4
	movlw		'i'
	call		LCD_Send
	retfie
	org 		7
; <M A I N   L O O P>
Main_Loop
	clrf		bit_in				; bit number	
	clrf		buffer_in			; bit buffer
	bcf			PORTB,		3		; clear data bit
	bcf			PORTB,		4		; clear monitor bit
; wait until the start bit is set
	btfss		PORTB,		7
	goto		$-1
; read bits, bit length = 209 us, bit period = 418 us
; byte start delay
	movlw		d'141'
	movwf		delL
	movlw		d'5'
	movwf		delH
	call		Delay
;<loop>
Byte_Loop
	bcf			flags, 		1		; clear data flag bit
; pre bit delay 35 us  
	movlw		d'7'
	movwf		delL
	movlw		d'0'
	movwf		delH
	call		Delay
; check bit 41 us
	bsf			PORTB,		4		; set monitor bit
	movlw		d'6'
	movwf		delL
	btfsc		PORTB, 		7
	bsf			flags, 		1		; set data flag bit
	btfsc		PORTB, 		7
	bsf			flags, 		1		; set data flag bit
	decfsz		delL,		f
	goto		$-5
	bcf			PORTB,		4		; clear monitor bit
; write bit to buffer_in
	bcf			STATUS, 	C
	btfsc		flags,		1
	bsf			STATUS, 	C
	rlf			buffer_in,	f
; output bit
	btfsc		flags,		1
	bsf			PORTB,		3		; set data bit
	btfss		flags,		1
	bcf			PORTB,		3		; clear data bit
; post bit delay  326 us
	movlw		d'104'
	movwf		delL
	movlw		d'0'
	movwf		delH
	call		Delay
; next bit, check if byte complete
	incf		bit_in, 	f
	btfss		bit_in, 	3
	goto		Byte_Loop	
;</loop>
; output
;	check if real byte
	movf		buffer_in,	w
	btfsc		STATUS,		Z
	goto		PostDelay
	call		LCD_WriteChar
	goto		PostDelay
	bcf			flags, 		6		; Disable LCD Data Mode	
	movlw		b'00000001'			; Clear display
	call		LCD_Send
	bsf			flags, 		6		; Enable LCD Data Mode
	call		LCD_Byte2Bin
; post byte delay
PostDelay
	movlw		d'255'
	movwf		delL
	movlw		d'255'
	movwf		delH
	call		Delay
	goto		Main_Loop
;</M A I N   L O O P>

;<LCD Routines>
LCD_WriteChar						;Takes the buffered
									;byte and presents it
;Is it a letter (0x04 to 0x1D)?
	movlw		0x1E
	subwf		buffer_in,	w
	btfsc		STATUS,		C
	goto		NoLetter
	movlw		0x3D
	addwf		buffer_in,	w
	call		LCD_Send
NoLetter
;Is it a space (0x2C)?
	movlw		0x2C
	subwf		buffer_in,	w
	btfss		STATUS,		Z
	goto		NoSpace
	movlw		' '
	call		LCD_Send
NoSpace
;Is it a delete (0x2A)?
	movlw		0x2A
	subwf		buffer_in,	w
	btfss		STATUS,		Z
	goto		NoDelete
	bcf			flags, 		6		; Disable LCD Data Mode	
	movlw		b'00000100'			; Change Direction
	call		LCD_Send
	bsf			flags, 		6		; Enable LCD Data Mode
	movlw		' '
	call		LCD_Send
	bcf			flags, 		6		; Disable LCD Data Mode	
	movlw		b'00000110'			; Change Direction
	call		LCD_Send
	bsf			flags, 		6		; Enable LCD Data Mode
NoDelete
	retlw		0



LCD_Byte2Bin						; out buffer_in
	clrf		bit_in
	movf		buffer_in,	w		; W = buffer_in
	movwf		Ruwido_Char			; Ruwido_Char = W
LCD_ByteLoop
	movlw		'0'
	movwf		temp				; temp = 0x30
	rlf			buffer_in, 	f		; Rotate Left
	btfsc		STATUS, 	C		; If Carry = High
	incf		temp, 		f		; temp ++
	movfw		temp				; W = temp
	call		LCD_Send
	incf		bit_in, 	f		; bit_in ++
	btfss		bit_in,		3		; If bit_in.3=Low
	goto		LCD_ByteLoop
	movlw		' '
	call		LCD_Send
	movlw		0x3D
	addwf		Ruwido_Char,w
	call		LCD_Send
	retlw		0

LCD_Send
	movwf		LCD_Byte
	call		LCD_Send_Nibble
;	second nibble
	call		LCD_Send_Nibble
	retlw		0

LCD_Send_Nibble
	swapf		LCD_Byte,	F
	movlw		b'00001111'
	andwf		LCD_Byte, 	W
	btfsc		flags, 		6
	iorlw		b'01000000'
	call		LCD_Latch
	bsf			PORTA, 		7
	call		LCD_Delay
	bcf			PORTA, 		7
	retlw		0

LCD_Init
	call		LCD_Delay
	movlw		b'00000010'
	call		LCD_Latch
	movlw		b'10000010'
	call		LCD_Latch
	movlw		b'00000010'
	call		LCD_Latch
;	4-bit mode is ON, 1st MSB, then LSB
	movlw		b'00101000'			; 4-bits, 2 lines, 5x8 dots
	call		LCD_Send
	movlw		b'00001111'			; Display on, Cursor on, Blinking on
	call		LCD_Send
	movlw		b'00000001'			; Clear display
	call		LCD_Send
	call		LCD_Delay_Long
	call		LCD_Delay_Long
	bsf			flags, 		6		; Enable LCD Data Mode
	retlw		0

LCD_Latch
	movwf		PORTA
	call		LCD_Delay
	retlw		0

LCD_Delay	
	movlw		d'0'
	movwf		delL
	movlw		d'2'
	movwf		delH
	call		Delay
	retlw		0

LCD_Delay_Long
	movlw		d'0'
	movwf		delL
	movlw		d'100'
	movwf		delH
	call		Delay
	retlw		0
;</LCD ROUTINES>

Delay			; delay time = 10 + L*3 + H*770 [us]
	incf		delL, 		f
	incf		delH, 		f
	decfsz		delL, 		f
	goto		$-1
	decfsz		delH, 		f
	goto		$-3
	retlw		0

;<Initialize>
Init
	clrf		flags				; flags = 0
	clrf		buffer_in			; buffer_in = 0
	banksel		ANSEL 				; BANK = BANKOF(ANSEL) (1)
	clrf 		ANSEL				; ANSEL = 0
	movlw		b'11100011'			; W = 0x..
	movwf		TRISB				; TRISB = W
	movlw		b'00100000'			; W = 0x..
	movwf		TRISA				; TRISA = W
	bcf			OPTION_REG, NOT_RBPU; do use pull-ups
	bcf			OPTION_REG, T0CS 	; TMR0 on internal clock
	bsf 		OSCCON, 	IRCF2 	; IRCF = 0b110
	bsf 		OSCCON, 	IRCF1	; (Internal Frequency = 4 MHz)
	bcf 		OSCCON, 	IRCF0	;
	movlw		b'00000000'			; W = 0x..
	movwf		OSCTUNE				; OSCTUNE = W
	banksel	INTCON 					; BANK = BANKOF(INTCON) (0)

Start
	call		LCD_Delay_Long
	call		LCD_Init
	call		LCD_Delay_Long
	movlw		'K'
	call		LCD_Send
	movlw		'I'
	call		LCD_Send
	movlw		'D'
	call		LCD_Send
	movlw		'S'
	call		LCD_Send
	movlw		' '
	call		LCD_Send
	call		LCD_Delay_Long
	nop
	clrf		PORTB
	nop
	goto		Main_Loop
;</Initialize>
	end

; mirror test
	btfsc		PORTB, 		7
	bsf			PORTB,		3
	btfss		PORTB, 		7
	bcf			PORTB,		3
	goto		$-4
	btfsc		flags,		0
	goto		PressFlag
	btfsc 		PORTB, 		7
	goto		PressFlag
	bsf			flags, 		0
PressFlag
	btfsc 		PORTB, 		7
	bcf			flags, 		0
	nop
	goto 		Main_Loop

; test pwm 50%, T = 430us @ 4MHz
	bsf			PORTB,		3
	movlw		d'66'
	movwf		delL
	movlw		d'0'
	movwf		delH
	call		Delay
	nop
	nop
	bcf			PORTB,		3
	movlw		d'66'
	movwf		delL
	movlw		d'0'
	movwf		delH
	call		Delay
	goto		Main_Loop
; end test